/* C header file for LOADERS MADE EASY V0.1
** Copyright (C) 1992 John Tisch
** This is a shareware product, BUT if you like what you see and would like
** the author to keep updating these functions please be sure to register
** your copy for $40.00. Registered users also get the COMPLETE SOURCE LIBRARY
** which includes many tips and pointers and C with .ASM programming etc.
** The best place of contact is via my BBS:
**
**                               The RUSH BBS
**                               (313)348-6057
**                           SySop: The Necromancer
**
*/

/* routines in MODE13SM.LIB */

extern  void    clearints(void);
/* Disables the special VGA Interrupt Handler.
**INPUT:  NOTHING
**
**OUTPUT: NOTHING
*/

extern  void    clearmem(int,int,unsigned int);
/* Used to clear a certain number of COMPLETE rows on the screen.
**
**INPUT:        INT:    The starting row number or Y coordinate
**              INT:    The number of rows to clear
**         UNSIGNED:    Page Address IE: A000/9000/8000 etc...
**                      Offset is ussumed to start a 0000
**
**OUTPUT: NOTHING
*/

extern  void    clearpals(void);
/* Can be used to blacken all 255 pallettes. (resets all colors to 0,0,0)
**INPUT:  NOTHING
**
**OUTPUT: NOTHING
*/

extern  void    cycleleft(int,int);
/* Used to rotate a specified amount of pallettes from right to left
**    REQUIRES THAT YOU HAVE 2 VARIABLES DEFINED IN YOUR C PROGRAM:
**      CHAR DEFAULTPAL[768],TMPPAL[768];
**
**INPUT:        INT:    Starting pallette number
**              INT:    Ending Pallette number
**
**OUTPUT: NOTHING
*/

extern  void    cycleright(int,int);
/* Used to rotate a specified amount of pallettes from left to right
**    REQUIRES THAT YOU HAVE 2 VARIABLES DEFINED IN YOUR C PROGRAM:
**      CHAR DEFAULTPAL[768],TMPPAL[768];
**
**INPUT:        INT:    Starting pallette number
**              INT:    Ending Pallette number
**
**OUTPUT: NOTHING
*/

extern  void    fadein(void);
/* Used to increment all 255 pallette colors by 1.
** REQUIRES THAT YOU HAVE 2 VARIABLES DEFINED IN YOUR C PROGRAM:
**          CHAR DEFAULTPAL[768],TMPPAL[768];
**
**INPUT:  NOTHING
**
**OUTPUT: NOTHING
*/

extern  void    fadeout(void);
/* Used to decrement all 255 pallette colors by 1. REQUIRES THAT
**      YOU HAVE 2 VARIABLES DEFINED IN YOUR C PROGRAM:
**          CHAR DEFAULTPAL[768],TMPPAL[768];
**
**INPUT:  NOTHING
**
**OUTPUT: NOTHING
*/

extern  void    font8x8(unsigned int, int, int, int);
/* Used to write text in mode 13hex STANDARD chained mode.
** NOTE: If 0 is passed
**INPUT:  UNSIGNED: Destination to write character ((Y*320)+X)
**             INT: Offset to start of character   (8*(ASCII VALUE))
**             INT: Number of pixels of character to write from left to right
**                  betweem 1 and 8 (BEST SUITED WITH SCROLLER FUNCTION).
**             INT: Color to Start With (Uses 8 consecutive Pallettes)
**                  (NOTE: If 0 is used for color than no pallette cycle
**                  (will be used!.)
**
**OUTPUT: NOTHING
*/

extern  void    fonttweak(unsigned int, int, int);
/* Used for writing text in the TWEAKED MODE
**INPUT:  UNSIGNED: Destination to write character ((Y*320)+X)
**             INT: Offset to start of character   (8*(ASCII VALUE))
**             INT: Color to Start With (Uses 8 consecutive Pallettes)
**
**OUTPUT: NOTHING
*/

extern  int     getraster(void);
/* Returns the current Scan Line The Vga Is In. Between 0-400.
** INTTERUPTS MUST BE SET PRIOR TO USING THIS FUNCTION!.
**INPUT:  NOTHING
**
**OUTPUT: Integer value between 0 and 400
*/

extern  void    line13(int, int, int, int, int);
/* Draws a line from point (X,Y)-(X1,Y1) and a color 0-255.
**INPUT:  INT: Starting X Location
**        INT: Starting Y Location
**        INT: Ending X Location
**        INT: Ending Y Location
**        INT: Color Of Line 0-255
**
**OUTPUT: NOTHING
*/

extern  void    scroller(unsigned int, int, int, unsigned);
/* Used for scrolling text from RIGHT to LEFT a WORD at a time.
**INPUT:  UNSIGNED: Destination to write character ((Y*320)+X)
**             INT: Number of COLUMNS*2 to scroll data
**             INT: Number of ROWS to scroll
**        UNSIGNED: Segment Address Of Scroll Surface (A000 for video)
**
**OUTPUT: VOID
*/

extern  void    setints(void);
/* Enables VGA Interrupt Handler. Be sure to enable the graphics mode prior
** to using this function.
**INPUT:  NOTHING
**
**OUTPUT: NOTHING
*/

extern  void    starfield(void);
/*  This will simply update the stars on the screen, which would include
**  erasing the old star and drawing the new one, also this will not
** write on top of ANY picture using pallettes 0-191. The starfield
** uses pallettes 192-224. Therefore it is upto you to color the pallettes
** to your liking. BUT MAKE SURE TO RUN THE STARSETUP FUNCTION FIRST!.
**INPUT:  NOTHING
**
**OUTPUT: NOTHING
*/

extern  void    starsetup(int,int,int);
/* Sets up the parameters for the starfield prior to using the STARFIELD()
** function above.
**INPUT:        INT:    Number of stars in starfield (1-150)
**              INT:    Rotation value DEFAULT is 20 can be any legal
**                      interger value between -250 thru +250.
**              INT:    This is an optional field but allows you to
**                      limit the height of the starfield IE: 150
**                      would limit the starfield from the top 0, to the
**                      bottom wich would be 150 leaving the other 50
**                      lines at the bottom clear.
**
**OUTPUT: NOTHING
*/

extern int stmik_init(int mode,int ioadd,int irq,int mixspd);
/*   mode: 1=SBC
**  ioadd: card I/O address; 0x220=default
**    irq: card IRQ number; 0x7=default
** mixspd: 20000=high,16000=normal,10000=low, higher=more processor time taken
** RETURN: nonzero=error
*/

extern char far *stmik_nequinfo(void);
/* note the note equ is NOT exactly in time (about 1/4 secs early)
** RETURN: far pointer to note equ
*/

extern int stmik_playsong(char far *module);
/* module: far pointer to module to be played (STX). The pointer MUST be
**         on a segment boundary; i.e. OFFSET part MUST be zero!
** RETURN: nonzero=error
*/

extern void stmik_poll(void);
/* must be called >10 times per second when pollmix is on.
** RETURN: none
*/

extern int stmik_setpollmix(int flag);
/*   flag: 0=no pollmix, 1=do pollmix
** RETURN: nonzero=error
*/

extern int stmik_songpos(void);
/* note the position is NOT exactly in time (about 1/4 secs early)
** RETURN: order+256*loop_count
*/

extern int stmik_stopsong(void);
/* RETURN: nonzero=error
*/

extern  void    tweakvideo(void);
/* This is used to enable the special non-chained 1280*200*256c Mode
** accept 256KB of Video Memory is REQUIRED for this mode.
**INPUT:  NOTHING
**
**OUTPUT: NOTHING
*/

extern  void    updatepals(int,int);
/* Used to update a specific amount of pallette registered based on
** your input values. (IE: writetmppal(10,100) would update 100 pallettes
** starting at pallette 10.)
**    REQUIRES THAT YOU HAVE 2 VARIABLES DEFINED IN YOUR C PROGRAM:
**      CHAR DEFAULTPAL[768],TMPPAL[768];
**
**INPUT:        INT:    Starting pallette number
**              INT:    Ending Pallette Number
**
**OUTPUT: NOTHING
*/

extern  void    vgaportout(int, char);
/* Used to output data to any address
**INPUT:   INT= A word address        IE: 0x3D4
**        CHAR= A byte value of data (Value between 0 & 255)
**
**OUTPUT: NOTHING
*/

extern  void    vgastate(int);
/*INPUT:  0 = OFF   Resets video to mode 3hex.
**        1 = ON    Enables Standard Mode 13hex (320*200*256).
**
**OUTPUT: NOTHING
*/

extern  void    waitborder1(void);
/* Used to wait for vertical retrace when intterupts are NOT set.
**
**INPUT: NOTHING
**
**OUTPUT: NOTHING
*/

extern  void    waitit(void);
/* Can be used to wait for vertical intterupt before continuing. Not
** neccessarily the best way, depending on application.
**INPUT:  NOTHING
**
**OUTPUT: NOTHING
*/
